function [Pre,Post,prob_trans,places,trans_strings,places_strings] = construct_PN2(T,Prob)
%construct the Petri net based on the Probability matrix prob:
%Pre is the pre-incidence matrix (defining the weights of the arcs from places to
%transitions)
%Post is the post incidence matrix containing the weights of the arcs from
%transitions to places

for i = 1 : size(T.adj,1)
    temp = setdiff(find(T.adj(i,:)),i);
    places.nplaces(i) = length(temp);
    places.adj{i} = temp;
end

Post=[];
Pre = [];

new_places = 0;
tab_places = [];
new_trans = 0;
for i = 1 : length(places.nplaces)
    for j = 1 : places.nplaces(i)
        new_places = new_places + 1;
        fprintf(1,'Add new place p%d modeling a robot in region %d entered from %d\n',new_places,i,places.adj{i}(j));
        places_strings{new_places} = sprintf('The robot is in region %d entered from %d',i,places.adj{i}(j));
        tab_places(new_places,:) = [i,places.adj{i}(j)];
        places.regions(new_places) = i;
    end
end

for i = 1 : length(places.nplaces)
      
    for j = 1 : places.nplaces(i)
        input_place = [];
        for l = 1 : size(tab_places,1)
            if (sum(tab_places(l,:) == [i,places.adj{i}(j)]) == 2)
                input_place = l;
                break;
            end
        end
        for k = 1 : places.nplaces(i)
            output_place = [];
            for l = 1 : size(tab_places,1)
                if (sum(tab_places(l,:) == [places.adj{i}(k),i]) == 2)
                    output_place = l;
                    break;
                end
            end
            %            if (Prob(i,places.adj{i}(k),places.adj{i}(j)) > 0.0001)
            new_trans = new_trans + 1;
            if (Prob(i,places.adj{i}(k),places.adj{i}(j)) > 0.0001)
                prob_trans(new_trans) = Prob(i,places.adj{i}(k),places.adj{i}(j));
            else
                prob_trans(new_trans) = 0;
            end
                Post(output_place,new_trans) = 1;
                Pre(input_place,new_trans) = 1;
                fprintf(1,'============================================================\n');
                fprintf(1,'Add new transition t%d for the move from p%d to p%d\n',new_trans,input_place,output_place);
                fprintf(1,'t(%d) is the move from region %d to region %d given that %d was entered from %d. \nThe probability is %s\n',new_trans,i,places.adj{i}(k),i,places.adj{i}(j),num2str(prob_trans(new_trans)));
                trans_strings{new_trans} = sprintf('t(%d): move from region %d to region %d given that %d was entered from %d',new_trans,i,places.adj{i}(k),i,places.adj{i}(j));
        end
    end
end
places.tab_places = tab_places;
