function prob = find_exit_probability_reentry(T,V,F_n,sj,D_A,D_B,D_b,control,time_step)
%from si we want to go to sj, when previous state was sj (sk==sj)
%one vertex of exit facet has negative projection on exit normal, the other positive

[ignore,ex_ind]=setdiff(V,T.Vert{sj},'rows');  %index of exit facet from si (common facet of si and sj)
other_vert=setdiff(1:3,ex_ind);  %vertices of common facet between si and sj
v1=V(other_vert(1),:)'; %vertices of common facet (column vectors)
v2=V(other_vert(2),:)';

%F_n(ex_ind,:) is the outer normal of exit facet to sj
vf_val_v1=D_A*v1+D_B*control*[v1;1]+D_b;    %vector field value at v1
vf_val_v2=D_A*v2+D_B*control*[v2;1]+D_b;    %vector field value at v2
if (F_n(ex_ind,:)*vf_val_v1<0) && (F_n(ex_ind,:)*vf_val_v2>=0)  %segment (v1,P) is not good
    syms lambda;
    P=lambda*v1+(1-lambda)*v2;  %symbolic point of exit facet
    vf_val=F_n(ex_ind,:)*(D_A*P+D_B*control*[P;1]+D_b); %vector field value at P
    lambda=double(solve(vf_val,lambda));    %a single solution (in interval [0,1])
    P=lambda*v1+(1-lambda)*v2; %point where projection to outer normal is zero
    prob=norm(v2-P)/norm(v2-v1);    %segment from P to v2 is good
elseif (F_n(ex_ind,:)*vf_val_v1>=0) && (F_n(ex_ind,:)*vf_val_v2<0)  %segment (P,v2) is not good
    syms lambda;
    P=lambda*v1+(1-lambda)*v2;  %symbolic point of exit facet
    vf_val=F_n(ex_ind,:)*(D_A*P+D_B*control*[P;1]+D_b); %vector field value at P
    lambda=double(solve(vf_val,lambda));    %a single solution (in interval [0,1])
    P=lambda*v1+(1-lambda)*v2; %point where projection to outer normal is zero
    prob=norm(P-v1)/norm(v2-v1);    %segment from P to v1 is good
elseif (F_n(ex_ind,:)*vf_val_v1>=0) && (F_n(ex_ind,:)*vf_val_v2>=0)  %both v1 and v2 are good
    prob=1;
else
    disp('Cannot exit to sj')
    prob=0;
end
