function answer = is_strongly_connected(Pre,Post)

already_checked = zeros(1,size(Pre,1));

to_check = 1;

while ~isempty(to_check)
    temp = find_outputs(to_check(1),Pre,Post);
    already_checked(to_check(1)) = 1;
    to_check(1) = [];
    
    for i = 1 : length(temp)
        if ((already_checked(temp(i)) == 0) && isempty(intersect(temp(i),to_check)))
            to_check = [to_check temp(i)];
        end
    end
end

if (length(find(already_checked)) ~= length(already_checked))
    answer = 0;
    fprintf(1,'=======================================================\n The net is not strongly connected. \nFor example, the following places are not reachable \nfrom p1: %s\n\n',...
        mat2str(find(already_checked==0)));
    return;
end

%check for the reverse net

temp = Pre;
Pre = Post;
Post = temp;
already_checked = zeros(1,size(Pre,1));

to_check = 1;

while ~isempty(to_check)
    temp = find_outputs(to_check(1),Pre,Post);
    already_checked(to_check(1)) = 1;
    to_check(1) = [];
    
    for i = 1 : length(temp)
        if ((already_checked(temp(i)) == 0) && isempty(intersect(temp(i),to_check)))
            to_check = [to_check temp(i)];
        end
    end
end

if (length(find(already_checked)) ~= length(already_checked))
    answer = 0;
    fprintf(1,'=======================================================\n The net is not strongly connected. \nFor example, from the following places is not possible\nto reach p1: %s\n\n',...
        mat2str(find(already_checked==0)));
    return;
end
answer = 1;
return


function places = find_outputs(place,Pre,Post)

places = [];
temp = find(Pre(place,:)); 
for i = 1 : length(temp)
    places = union(places,find(Post(:,temp(i))));
end
return