function [h_vf] = plot_vect_field(V, control,D_A,D_B,D_b,points)
%plots vector field in a region with vertices V and control given by "control" matrix

% H=cddmex('hull',struct('V',V));    %H-repres of polytope (facets are given by H.A x - H.B = 0)
% prec2=1e-9;

%find numbers of points on each axis
step_x=(max(V(:,1)) - min(V(:,1)))/points;
step_y=(max(V(:,2)) - min(V(:,2)))/points;
step=0.25;%min([step_x,step_y]);  %step on both directions
p_x=round((max(V(:,1)) - min(V(:,1)))/step);    %points on x axis
p_y=round((max(V(:,2)) - min(V(:,2)))/step);

[Xg,Yg]=meshgrid(linspace(min(V(:,1)),max(V(:,1)),p_x) , linspace(min(V(:,2)),max(V(:,2)),p_y));  %grid to represent v.f.
Gx=zeros(size(Xg));
Gy=zeros(size(Yg));

for i=1:size(Xg,1)
    for j=1:size(Xg,2)
        P=[Xg(i,j),Yg(i,j)];
        if inpolygon(P(1),P(2),V(:,1),V(:,2))
%         if sum(H.A*P'-H.B <=prec2)==3
%             Gx = D_A(1,1)*Xg + D_A(1,2)*Yg + D_b(1,1);    %values of projection of v.f. on the first axis (X,Y are matrices, that's why we write result as sum of products with scalars)
%             Gy = D_A(2,1)*Xg + D_A(2,2)*Yg + D_b(2,1);    %projection of v.f. on the second axis
            r_v=D_A*P'+D_B*control*[P';1]+D_b;
            Gx(i,j)=r_v(1);
            Gy(i,j)=r_v(2);
        else
            Xg(i,j)=0;
            Yg(i,j)=0;
        end
    end
end 

h_vf=quiver(Xg,Yg,Gx,Gy,'k','Linewidth',1);
% set(h_vf,'AutoScaleFactor',0.2);    %auto scale with smaller factor (default is 0.9)
